library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity a_loop is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    ap_start : IN STD_LOGIC;
    ap_done : OUT STD_LOGIC;
    ap_idle : OUT STD_LOGIC;
    ap_ready : OUT STD_LOGIC;
    a : IN STD_LOGIC_VECTOR (31 downto 0);
    ap_return : OUT STD_LOGIC_VECTOR (31 downto 0) );
end;

architecture rtl of a_loop is
signal CS: STD_LOGIC_VECTOR (0 downto 0) := "0";
signal NS: STD_LOGIC_VECTOR (0 downto 0);
signal int_a : STD_LOGIC_VECTOR (31 downto 0);
signal i: STD_LOGIC_VECTOR (3 downto 0);
signal exit_cond: STD_LOGIC_VECTOR (0 downto 0);

begin
CS_fsm : process(ap_clk)
begin
if (ap_clk'event and ap_clk = '1') then
if (ap_rst = '1') then
CS <= "0";
else
CS <= NS;
end if;
end if;
end process;

NS_fsm: process(ap_start, CS, exit_cond)
begin
if ((CS = "1") and (exit_cond = "1")) then
NS <= "0";
elsif (((CS = "0") and (ap_start = '1')) or
((CS = "1") and (exit_cond = "0"))) then
NS <= "1";
else
NS <= CS;
end if;
end process;

reg_proc : process(ap_clk)
begin
if (ap_clk'event and ap_clk = '1') then
if ((CS = "1") and (exit_cond = "0")) then
int_a <= std_logic_vector(shift_left(unsigned(int_a), 2) + unsigned(int_a) );
elsif ((CS = "0") and (ap_start = '1'))
then
int_a <= a;
end if;
if ((CS = "1") and (exit_cond = "0")) then
i <= std_logic_vector(unsigned(i) + 1);
elsif ((CS = "0") and (ap_start = '1'))
then
i <= "0000";
end if;
end if;
end process;

ap_return <= int_a;

ap_done_proc : process(CS, exit_cond)
begin
if ((CS = "1") and (exit_cond = "1")) then
ap_done <= '1';
else
ap_done <= '0';
end if;
end process;
ap_idle_proc : process(ap_start, CS)
begin
if ((ap_start = '0') and (CS = "0")) then
ap_idle <= '1';
else
ap_idle <= '0';
end if;
end process;

ap_ready_proc : process(CS, exit_cond)
begin
if ((CS = "1") and (exit_cond = "1")) then
ap_ready <= '1';
else
ap_ready <= '0';
end if;
end process;
exit_cond <= "1" when (i = "1010") else "0";
end rtl;


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
entity test_a_loop is end test_a_loop;

architecture test of test_a_loop is

component a_loop is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    ap_start : IN STD_LOGIC;
    ap_done : OUT STD_LOGIC;
    ap_idle : OUT STD_LOGIC;
    ap_ready : OUT STD_LOGIC;
    a : IN STD_LOGIC_VECTOR (31 downto 0);
    ap_return : OUT STD_LOGIC_VECTOR (31 downto 0));
end component;

signal ap_clk: STD_LOGIC := '1';
signal ap_rst, ap_start, ap_done, ap_idle, ap_ready: STD_LOGIC;
signal a: STD_LOGIC_VECTOR (31 downto 0);
signal ap_return: STD_LOGIC_VECTOR (31 downto 0);


begin

dut: a_loop port map (
    ap_clk => ap_clk, ap_rst => ap_rst, ap_start => ap_start, ap_done => ap_done,
    ap_idle => ap_idle, ap_ready => ap_ready, a => a, ap_return => ap_return);

ap_clk <= not(ap_clk) after 50 ns;

ap_rst <= '1', '0' after 100 ns;

ap_start <= '0', '1' after 200 ns, '0' after 300 ns, '1' after 2500 ns, '0' after 2600 ns;

a <= x"00000005", x"00000007" after 2500 ns;

end test;
