LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE WORK.coprocessor_parameters.ALL;
ENTITY arbiter IS
PORT (
    clk, Req1, Req2: IN STD_LOGIC;
    Grant1, Grant2: OUT STD_LOGIC
);
END arbiter;

ARCHITECTURE data_flow OF arbiter IS

  PROCEDURE sync IS BEGIN WAIT UNTIL clk'EVENT AND clk = '1'; END sync;

BEGIN

PROCESS
BEGIN
   Grant1 <= '0'; Grant2 <= '0';
   LOOP
      IF Req1 = '1' THEN sync; Grant1 <= '1';
         WAIT UNTIL Req1 = '0'; sync;
         Grant1 <= '0';
      ELSIF Req2 = '1' THEN sync; Grant2 <= '1';
         WAIT UNTIL Req2 = '0'; sync;
         Grant2 <= '0';
      ELSE sync;
      END IF;
   END LOOP;
END PROCESS;

END data_flow;
