LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
ENTITY counter IS
PORT (
clk, reset, count_enable: IN STD_LOGIC;
y: OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
);
END counter;

ARCHITECTURE behavior OF counter IS

  SIGNAL next_state, current_state: STD_LOGIC_VECTOR(2 DOWNTO 0);

BEGIN

  next_state <= current_state + count_enable;
  
  synchronization: PROCESS(reset, clk)
  BEGIN
    IF reset = '1' THEN current_state <= "000";
    ELSIF clk'EVENT AND clk = '1' THEN current_state <= next_state;
    END IF;
  END PROCESS synchronization;

   y <= current_state;

end behavior;
