--------------------------------------------------------------------------------
-- Copyright (c) 1995-2012 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: P.40xd
--  \   \         Application: netgen
--  /   /         Filename: counter_synthesis.vhd
-- /___/   /\     Timestamp: Fri Mar 23 16:53:04 2018
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -ar Structure -tm counter -w -dir netgen/synthesis -ofmt vhdl -sim counter.ngc counter_synthesis.vhd 
-- Device	: xc3s50-5-pq208
-- Input file	: counter.ngc
-- Output file	: C:\Users\Jean-Pierre\book4\NewChapterISE\ISEcounter\netgen\synthesis\counter_synthesis.vhd
-- # of Entities	: 1
-- Design Name	: counter
-- Xilinx	: C:\Xilinx\14.3\ISE_DS\ISE\
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Command Line Tools User Guide, Chapter 23
--     Synthesis and Simulation Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--library UNISIM;
--use UNISIM.VCOMPONENTS.ALL;
--use UNISIM.VPKG.ALL;

use WORK.VCOMPONENTS.ALL;
use WORK.VPKG.ALL;


entity counter is
  port (
    clk : in STD_LOGIC := 'X'; 
    reset : in STD_LOGIC := 'X'; 
    count_enable : in STD_LOGIC := 'X'; 
    y : out STD_LOGIC_VECTOR ( 2 downto 0 ) 
  );
end counter;

architecture Structure of counter is
  signal clk_BUFGP_4 : STD_LOGIC; 
  signal count_enable_IBUF_6 : STD_LOGIC; 
  signal reset_IBUF_11 : STD_LOGIC; 
  signal Result : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal current_state : STD_LOGIC_VECTOR ( 2 downto 0 ); 
begin
  current_state_0 : FDCE
    port map (
      C => clk_BUFGP_4,
      CE => count_enable_IBUF_6,
      CLR => reset_IBUF_11,
      D => Result(0),
      Q => current_state(0)
    );
  current_state_1 : FDCE
    port map (
      C => clk_BUFGP_4,
      CE => count_enable_IBUF_6,
      CLR => reset_IBUF_11,
      D => Result(1),
      Q => current_state(1)
    );
  current_state_2 : FDCE
    port map (
      C => clk_BUFGP_4,
      CE => count_enable_IBUF_6,
      CLR => reset_IBUF_11,
      D => Result(2),
      Q => current_state(2)
    );
  Mcount_current_state_xor_1_11 : LUT2
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => current_state(1),
      I1 => current_state(0),
      O => Result(1)
    );
  Mcount_current_state_xor_2_11 : LUT3
    generic map(
      INIT => X"6A"
    )
    port map (
      I0 => current_state(2),
      I1 => current_state(1),
      I2 => current_state(0),
      O => Result(2)
    );
  reset_IBUF : IBUF
    port map (
      I => reset,
      O => reset_IBUF_11
    );
  count_enable_IBUF : IBUF
    port map (
      I => count_enable,
      O => count_enable_IBUF_6
    );
  y_2_OBUF : OBUF
    port map (
      I => current_state(2),
      O => y(2)
    );
  y_1_OBUF : OBUF
    port map (
      I => current_state(1),
      O => y(1)
    );
  y_0_OBUF : OBUF
    port map (
      I => current_state(0),
      O => y(0)
    );
  clk_BUFGP : BUFGP
    port map (
      I => clk,
      O => clk_BUFGP_4
    );
  Mcount_current_state_xor_0_11_INV_0 : INV
    port map (
      I => current_state(0),
      O => Result(0)
    );

end Structure;


LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
ENTITY test_counter IS END test_counter;

ARCHITECTURE test OF test_counter IS

COMPONENT counter IS
PORT (
clk, reset, count_enable: IN STD_LOGIC;
y: OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
);
END COMPONENT;

SIGNAL clk: STD_LOGIC := '1';
SIGNAL reset, count_enable: STD_LOGIC;
SIGNAL y: STD_LOGIC_VECTOR(2 DOWNTO 0);

BEGIN

dut: counter PORT MAP(clk => clk, reset => reset, count_enable => count_enable, y => y);

clk <= NOT(clk) AFTER 50 NS;
reset <= '1', '0' AFTER 200 NS;
count_enable <= '0', '1' AFTER 1500 NS, '0' AFTER 3000 NS;

END test;