LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE WORK.coprocessor_parameters.ALL;
ENTITY data_memory IS
PORT (
    data_in: IN SIGNED(p-1 DOWNTO 0);
    address_in: IN STD_LOGIC_VECTOR(s-1 DOWNTO 0); 
    clk, ADS_in, write_in: IN STD_LOGIC;
    data_out: OUT SIGNED(p-1 DOWNTO 0)
);
END data_memory;

ARCHITECTURE data_flow OF data_memory IS

  PROCEDURE sync IS BEGIN WAIT UNTIL clk'EVENT AND clk = '1'; END sync;

  SIGNAL memory_contents: memory; 

BEGIN

PROCESS

BEGIN

  LOOP

--initial state
     data_out <= (OTHERS => 'Z'); sync;
--read
     IF address_in(9) = '1' AND ADS_in = '1' AND write_in = '0' THEN 
       data_out <= memory_contents(CONV_INTEGER(address_in(8 DOWNTO 0))); sync;
--write
     ELSIF address_in(9) = '1' AND ADS_in = '1' AND write_in <= '1' THEN 
        memory_contents(CONV_INTEGER(address_in(8 DOWNTO 0))) <= data_in; sync;
--nop
--     ELSE sync;
     END IF;

   END LOOP;

END PROCESS;

END data_flow;



