LIBRARY IEEE; USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE work.mod_m.ALL;
USE IEEE.MATH_REAL.ALL; -- for UNIFORM, TRUNC
ENTITY encoding_system IS
  PORT(
    clk, reset: IN STD_LOGIC;    
    z: OUT STD_LOGIC_VECTOR(k-1 DOWNTO 0)
);
END encoding_system;

ARCHITECTURE circuit OF encoding_system IS

COMPONENT signal_generator IS 
  PORT(
    clk, reset, exp_done: IN STD_LOGIC;
    x, y: OUT STD_LOGIC_VECTOR(k-1 DOWNTO 0);
    start_exp: OUT STD_LOGIC
  );
END COMPONENT;

COMPONENT mod_m_exponent IS 
  PORT(
    x, y: IN STD_LOGIC_VECTOR(k-1 DOWNTO 0);
    clk, reset, start: STD_LOGIC;
    z: OUT STD_LOGIC_VECTOR(k-1 DOWNTO 0);
    done: OUT STD_LOGIC
  );
END COMPONENT;

SIGNAL x, y: STD_LOGIC_VECTOR(k-1 DOWNTO 0);
SIGNAL start_exp, exp_done: STD_LOGIC;

BEGIN

first_component: signal_generator
  PORT MAP(clk => clk, reset => reset, exp_done => exp_done,
    x => x, y => y, start_exp => start_exp);

second_component: mod_m_exponent 
  PORT MAP(x => x, y => y, clk => clk, reset => reset, 
    start => start_exp, z => z, done => exp_done);

END circuit;


LIBRARY IEEE; USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE work.mod_m.ALL;
ENTITY test_encoding_system IS END test_encoding_system;

ARCHITECTURE test OF test_encoding_system IS

COMPONENT encoding_system IS
  PORT(
    clk, reset: IN STD_LOGIC;    
    z: OUT STD_LOGIC_VECTOR(k-1 DOWNTO 0)
);
END COMPONENT;

SIGNAL clk: STD_LOGIC := '0';
SIGNAL reset: STD_LOGIC;
SIGNAL z: STD_LOGIC_VECTOR(k-1 DOWNTO 0);

BEGIN

dut: encoding_system 
  PORT MAP(
    clk => clk, reset => reset, z => z);

clk <= NOT(clk) AFTER 50 NS;

reset <= '1', '0' AFTER 100 NS;

END test;