#include "hls_processor.h"


void hls_processor (bool reset, data IN0, data IN1, data IN2, data IN3, data IN4, data IN5, data IN6, data IN7,
		instruction_field code, instruction_field i, instruction_field j, instruction_field k,
		data * OUT0, data * OUT1, data * OUT2, data * OUT3, data * OUT4, data * OUT5, data * OUT6, data * OUT7,
		address * number){
#pragma HLS INTERFACE ap_ctrl_none port=return

	static data X[16];

	static address pc;

	data input_port[8];
	input_port[0] = IN0; input_port[1] = IN1; input_port[2] = IN2; input_port[3] = IN3;
	input_port[4] = IN4; input_port[5] = IN5; input_port[6] = IN6; input_port[7] = IN7;

	static data output_port [8];

	if (reset == 1) pc = 0;

	else {

		switch (code)
		{
		case 0: {
			X[k] = j + 16*i; pc = pc + 1;
			}
			break;
		case 2: {
			X[k] = input_port[k];  pc = pc + 1;
			}
			break;
		case 10: {
			output_port[i] = X[j]; pc = pc + 1;
			}
			break;
		case 8: {
			output_port[i] = k + 16*j; pc = pc + 1;
			}
			break;
		case 4: {
			X[k] = X[i] + X[j]; pc = pc + 1;
			}
			break;
		case 5: {
			X[k] = X[i] - X[j]; pc = pc + 1;
			}
			break;
		case 14: {
			pc = k + 16*j;
			}
			break;
		case 12: {
			if (X[i] > 0) pc = k + 16*j; else pc = pc + 1;
			}
			break;
		case 13: {
			if (X[i] < 0) pc = k + 16*j; else pc = pc + 1;
			}
			break;
		}
	}

	*OUT0 = output_port[0]; *OUT1 = output_port[1]; *OUT2 = output_port[2]; *OUT3 = output_port[3];
	*OUT4 = output_port[4]; *OUT5 = output_port[5]; *OUT6 = output_port[6]; *OUT7 = output_port[7];

	*number = pc;

}
