----------------------------------------------------------------------------
-- mod m addition; 
--
----------------------------------------------------------------------------
LIBRARY IEEE; USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
PACKAGE mod_m IS
  CONSTANT k: NATURAL := 8;
  CONSTANT m: STD_LOGIC_VECTOR(k-1 DOWNTO 0):= x"5b";
--minus_m = 256 - 91 = 165
  CONSTANT minus_m: STD_LOGIC_VECTOR(k-1 DOWNTO 0):= x"a5";
  CONSTANT zero: STD_LOGIC_VECTOR(k-1 DOWNTO 0):= x"00";
  CONSTANT one: STD_LOGIC_VECTOR(k-1 DOWNTO 0):= x"01";
END mod_m;

LIBRARY IEEE; USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE work.mod_m.ALL;
ENTITY mod_m_adder IS
PORT(
x, y: IN STD_LOGIC_VECTOR(k-1 DOWNTO 0);
z: OUT STD_LOGIC_VECTOR(k-1 DOWNTO 0)
);
END mod_m_adder;

ARCHITECTURE circuit OF mod_m_adder IS

SIGNAL x_plus_y, x_plus_y_minus_m: STD_LOGIC_VECTOR(k DOWNTO 0);

BEGIN

x_plus_y <= ('0'&x) + ('0'&y);

x_plus_y_minus_m <= x_plus_y + minus_m;

WITH x_plus_y_minus_m(k) SELECT z <= x_plus_y(k-1 DOWNTO 0) WHEN '0', 
     x_plus_y_minus_m(k-1 DOWNTO 0) WHEN OTHERS;

END circuit;  


LIBRARY IEEE; USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE work. mod_m.ALL;
ENTITY test_mod_m_adder IS END test_mod_m_adder;

ARCHITECTURE test OF test_mod_m_adder IS

COMPONENT mod_m_adder IS
PORT(
x, y: IN STD_LOGIC_VECTOR(k-1 DOWNTO 0);
z: OUT STD_LOGIC_VECTOR(k-1 DOWNTO 0)
);
END COMPONENT;

SIGNAL x, y, z: STD_LOGIC_VECTOR(k-1 DOWNTO 0);

BEGIN

dut: mod_m_adder
  PORT MAP(x => x, y => y, z => z);

x <= x"43", x"1f" AFTER 200 NS;
y <= x"25", x"1f" AFTER 100 NS;

END test;