LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
entity pp_loop is
port (
    clk : IN STD_LOGIC;
    rst : IN STD_LOGIC;
    start : IN STD_LOGIC;
    done : OUT STD_LOGIC;
    a : IN STD_LOGIC_VECTOR (31 downto 0);
    data_return : OUT STD_LOGIC_VECTOR (31 downto 0) );
end;

architecture rtl of pp_loop is

signal a_1, a_2, a_3, a_4, a_5, a_6, a_7, a_8, a_9,
  a_1d, a_2d, a_3d, a_4d, a_5d, a_6d, a_7d, a_8d, a_9d: STD_LOGIC_VECTOR (31 downto 0);
signal it0: std_logic;
signal it: std_logic_vector(1 to 9);
constant two: std_logic_vector(1 downto 0) := "10";

begin
  a_1 <= shl(a, two) + a;
  a_2 <= shl(a_1d, two) + a_1d;
  a_3 <= shl(a_2d, two) + a_2d;
  a_4 <= shl(a_3d, two) + a_3d;
  a_5 <= shl(a_4d, two) + a_4d;
  a_6 <= shl(a_5d, two) + a_5d;
  a_7 <= shl(a_6d, two) + a_6d;
  a_8 <= shl(a_7d, two) + a_7d;
  a_9 <= shl(a_8d, two) + a_8d;
  data_return <= shl(a_9d, two) + a_9d;

reg_1: process(clk)
begin if clk'event and clk = '1' then if it0 = '1' then a_1d <= a_1; end if; 
end if; end process;    
reg_2: process(clk)
begin if clk'event and clk = '1' then if it(1) = '1' then a_2d <= a_2; end if; 
end if; end process;    
reg_3: process(clk)
begin if clk'event and clk = '1' then if it(2) = '1' then a_3d <= a_3; end if; 
end if; end process;    
reg_4: process(clk)
begin if clk'event and clk = '1' then if it(3) = '1' then a_4d <= a_4; end if; 
end if; end process;    
reg_5: process(clk)
begin if clk'event and clk = '1' then if it(4) = '1' then a_5d <= a_5; end if; 
end if; end process;    
reg_6: process(clk)
begin if clk'event and clk = '1' then if it(5) = '1' then a_6d <= a_6; end if; 
end if; end process;    
reg_7: process(clk)
begin if clk'event and clk = '1' then if it(6) = '1' then a_7d <= a_7; end if; 
end if; end process;    
reg_8: process(clk)
begin if clk'event and clk = '1' then if it(7) = '1' then a_8d <= a_8; end if; 
end if; end process;    
reg_9: process(clk)
begin if clk'event and clk = '1' then if it(8) = '1' then a_9d <= a_9; end if; 
end if; end process;    

it0 <= start;
shift_register: process(clk)
begin
   if clk'event and clk = '1' then 
      if rst = '1' then it <= (others => '0');
      else it <= it0&it(1 to 8);
      end if;
   end if;
end process;
   
done <= it(9);

end rtl;


