LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
--USE IEEE.STD_LOGIC_ARITH.ALL;
--USE IEEE.STD_LOGIC_UNSIGNED.ALL;
ENTITY protocol IS
PORT (
  clk, reset, req_in, ack_in, done: IN STD_LOGIC;
  req_out, ack_out, ce, start: OUT STD_LOGIC
);
END protocol;

ARCHITECTURE data_flow OF protocol IS
  PROCEDURE sync IS
  BEGIN
    WAIT UNTIL clk'EVENT AND clk = '1';
  END sync;
BEGIN
  PROCESS
  BEGIN
   ce <= '0'; start <= '0'; req_out <= '0'; ack_out <= '0'; sync;
    LOOP
      IF reset = '1' THEN EXIT; END IF;
      IF req_in = '1'THEN
        ce <= '1'; sync;
        ce <= '0'; ack_out <= '1'; sync; 
        ack_out <= '0'; start <= '1'; sync;
        start <= '0';
        WAIT UNTIL done = '1';
        req_out <= '1';
        WAIT UNTIL ack_in = '1';
        req_out <= '0'; sync;
      ELSE sync;
      END IF;  
    END LOOP;
  END PROCESS;
END data_flow;

