LIBRARY IEEE; USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

use IEEE.MATH_REAL.ALL; -- for UNIFORM, TRUNC

USE work.mod_m.ALL;
ENTITY random_generator IS 
  PORT(
    clk, reset: IN STD_LOGIC;
    x: OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
  );
END random_generator;

ARCHITECTURE behavior OF random_generator IS

BEGIN

  PROCESS
      VARIABLE seed1: NATURAL := 844396720;
      VARIABLE seed2: NATURAL := 821616997;  
      VARIABLE rand: REAL;
      VARIABLE int_x: NATURAL;
  BEGIN
    FOR i IN 0 TO 100 LOOP
        UNIFORM(seed1, seed2, rand);
        int_x := INTEGER(TRUNC(rand*real(2**30)));
        x <= CONV_STD_LOGIC_VECTOR(int_x,32);
        WAIT FOR 100 NS;
     END LOOP;   
END PROCESS;

END behavior;