LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
entity rtl_loop is
port (
    clk : IN STD_LOGIC;
    rst : IN STD_LOGIC;
    start : IN STD_LOGIC;
    done : OUT STD_LOGIC;
    a : IN STD_LOGIC_VECTOR (31 downto 0);
    data_return : OUT STD_LOGIC_VECTOR (31 downto 0) );
end;

architecture rtl of rtl_loop is
signal CS: STD_LOGIC_VECTOR (0 downto 0) := "0";
signal NS: STD_LOGIC_VECTOR (0 downto 0);
signal int_a : STD_LOGIC_VECTOR (31 downto 0);
signal i: STD_LOGIC_VECTOR (3 downto 0);
signal exit_cond: STD_LOGIC_VECTOR (0 downto 0);

constant two: std_logic_vector(1 downto 0) := "10";

begin

fsm_with_operations: process(clk)
begin
if (clk'event and clk = '1') then
   if (rst = '1') then CS <= "0"; done <= '0';
   elsif (CS = "0") and (start = '1') then CS <= "1"; int_a <= a; i <= "0000"; done <= '0';
   elsif (CS = "1") and (exit_cond = "0") then 
      int_a <= shl(int_a, two) + int_a;
      i <= i + 1; done <= '0';      
   elsif (CS = "1") and (exit_cond = "1") then CS <= "0"; done <= '1';
   end if;
end if;
end process;

data_return <= int_a;

exit_cond <= "1" when (i = "1010") else "0";

end rtl;

