LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE WORK.scalar_product_parameters.ALL;
ENTITY test_scalar_product IS END test_scalar_product;

ARCHITECTURE test OF test_scalar_product IS

  COMPONENT scalar_product IS
  PORT (
      xP, k: IN STD_LOGIC_VECTOR(M-1 DOWNTO 0);
      clk, reset, start: IN STD_LOGIC;
      xA, zA, xB, zB: INOUT STD_LOGIC_VECTOR(M-1 DOWNTO 0);
      done: OUT STD_LOGIC );
  END COMPONENT;

  SIGNAL xP, k: STD_LOGIC_VECTOR(M-1 DOWNTO 0);
  SIGNAL reset, start: STD_LOGIC;
  SIGNAL clk: STD_LOGIC := '0';
  SIGNAL xA, zA, xB, zB: STD_LOGIC_VECTOR(M-1 DOWNTO 0);
  SIGNAL done: STD_LOGIC ;

BEGIN

dut: scalar_product
PORT MAP (xP => xP, k => k, clk => clk, reset => reset, start => start,
xA => xA, xB => xB, zA => zA, zB => zB, done => done);

clk <= not(clk) AFTER 50 ns;

test_vectors: PROCESS
BEGIN
xP <= "010" & x"fe13c0537bbc11acaa07d793de4e6d5e5c94eee8";
k <= "100" & x"000000000000000000020108a2e0cc0d99f8a5ee";
reset <= '1';
start <= '0';
WAIT FOR 100 ns;
reset <= '0';
WAIT FOR 100 ns;
start <= '1';
WAIT FOR 100 ns;
start <= '0';
WAIT;
END PROCESS;

END test;

