LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
entity unroll_loop is
port (
    a : IN STD_LOGIC_VECTOR (31 downto 0);
    data_return : OUT STD_LOGIC_VECTOR (31 downto 0) );
end;

architecture rtl of unroll_loop is

signal a_1, a_2, a_3, a_4, a_5, a_6, a_7, a_8, a_9: STD_LOGIC_VECTOR (31 downto 0);
constant two: std_logic_vector(1 downto 0) := "10";

begin
  a_1 <= shl(a, two) + a;
  a_2 <= shl(a_1, two) + a_1;
  a_3 <= shl(a_2, two) + a_2;
  a_4 <= shl(a_3, two) + a_3;
  a_5 <= shl(a_4, two) + a_4;
  a_6 <= shl(a_5, two) + a_5;
  a_7 <= shl(a_6, two) + a_6;
  a_8 <= shl(a_7, two) + a_7;
  a_9 <= shl(a_8, two) + a_8;
  data_return <= shl(a_9, two) + a_9;
end rtl;


LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
entity test_unroll_loop is end test_unroll_loop;

architecture test of test_unroll_loop is

component unroll_loop is
port (
    a : IN STD_LOGIC_VECTOR (31 downto 0);
    data_return : OUT STD_LOGIC_VECTOR (31 downto 0));
end component;

signal a: STD_LOGIC_VECTOR (31 downto 0);
signal data_return: STD_LOGIC_VECTOR (31 downto 0);

begin

dut: unroll_loop port map (a => a, data_return => data_return);

a <= x"00000005", x"00000007" after 2500 ns;

end test;
